VERSION 5.00
Begin VB.Form FrmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Bezier Curve Example"
   ClientHeight    =   6375
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   8400
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   425
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   560
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox PBox 
      BackColor       =   &H00000000&
      Height          =   6015
      Left            =   0
      ScaleHeight     =   397
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   557
      TabIndex        =   0
      Top             =   0
      Width           =   8415
   End
   Begin VB.Label Desc 
      BackStyle       =   0  'Transparent
      Caption         =   "Click on the Field above to create 4 Control Points for the Bezier Curve. Press a 5th time to clear"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   6000
      Width           =   8415
   End
End
Attribute VB_Name = "FrmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Type Point2D                                                'A custom Point Type
    X As Long
    Y As Long
End Type

Private C1 As Point2D, C2 As Point2D, C3 As Point2D, C4 As Point2D  'Our 4 Control points
Private ClickCount As Integer

Public Sub DrawBezier()                                             'This sub draws the Curve
    Dim V1 As Point2D, V2 As Point2D, Time As Single                'Some Locals
    Dim a1 As Single, a2 As Single, a3 As Single, a4 As Single
    
    V2 = C1                                                         'Just to avoid some 'artifacts'
    
    For k = 0 To 1000                                               'For every Point on the Curve...
        Time = k / 1000                                             'This is because i didn't want to use:
                                                                    'for k = 0 to 1 step 0.001, and stuff like that
        a1 = -Time * Time * Time + Time * Time * 3 - 3 * Time + 1   'Altough this could use some Optimisation, it's clearer
        a2 = Time * Time * Time * 3 - 6 * Time * Time + 3 * Time    'this way.
        a3 = -3 * Time * Time * Time + 3 * Time * Time
        a4 = Time * Time * Time
                
        V1.X = a1 * C1.X + a2 * C2.X + a3 * C3.X + a4 * C4.X        'Here we actually compute the Point on the curve
        V1.Y = a1 * C1.Y + a2 * C2.Y + a3 * C3.Y + a4 * C4.Y
        
        PBox.Line (V2.X, V2.Y)-(V1.X, V1.Y), RGB(255, 255, 255)     'And now we draw it in white
        V2 = V1                                                     'for the next round
    Next k                                                          'next point
    
    PBox.Line (C1.X, C1.Y)-(C2.X, C2.Y), RGB(255, 255, 0)           'For testing reasons, shows how it would
    PBox.Line (C2.X, C2.Y)-(C3.X, C3.Y), RGB(255, 255, 0)           'look like if it wasn't a curve
    PBox.Line (C3.X, C3.Y)-(C4.X, C4.Y), RGB(255, 255, 0)

End Sub

Private Sub PBox_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'if we press the button...
    ClickCount = ClickCount + 1                                     'So we know which Control point we are using
    If ClickCount = 1 Then                                          'if it's nummero Uno...
        C1.X = X                                                    'set the X,Y coord for the Point
        C1.Y = Y
        PBox.Circle (X, Y), 5, RGB(255, 0, 0)                       'and draw a lil' ball at it's point... for beauty reasons
    ElseIf ClickCount = 2 Then                                      'number 2...
        C2.X = X
        C2.Y = Y
        PBox.Circle (X, Y), 5, RGB(255, 0, 0)
    ElseIf ClickCount = 3 Then                                      'and 3..
        C3.X = X
        C3.Y = Y
        PBox.Circle (X, Y), 5, RGB(255, 0, 0)
    ElseIf ClickCount = 4 Then                                      'and the last one..
        C4.X = X
        C4.Y = Y
        PBox.Circle (X, Y), 5, RGB(255, 0, 0)
        DrawBezier                                                  'since it's the last,we might as well draw the curve, eh?
    ElseIf ClickCount > 4 Then                                      'if we click once more (5th time) the screen clears
        ClickCount = 0                                              'and we can start all over again, yay :)
        PBox.Cls                                                    'if you want to overdraw the last curve, just remove this
    End If
End Sub
